searchNodes=[{"doc":"RGBMatrix is a rendering engine for the Nerves Keyboard project. It schedules and renders frames. There is a small selection of animations built in.","ref":"RGBMatrix.html","title":"RGBMatrix","type":"module"},{"doc":"","ref":"RGBMatrix.html#t:any_color_model/0","title":"RGBMatrix.any_color_model/0","type":"type"},{"doc":"Provides the behaviour and interface for working with animations.","ref":"RGBMatrix.Animation.html","title":"RGBMatrix.Animation","type":"behaviour"},{"doc":"Defines a configuration field for an animation.Example:field :speed, :integer, default: 4, min: 0, max: 32, doc: [ name: &quot;Speed&quot;, description: &quot;&quot;&quot; Controls the speed at which the wave moves across the matrix. &quot;&quot;&quot; ]","ref":"RGBMatrix.Animation.html#field/3","title":"RGBMatrix.Animation.field/3","type":"macro"},{"doc":"Gets the current configuration and the configuration schema from an animation.","ref":"RGBMatrix.Animation.html#get_config/1","title":"RGBMatrix.Animation.get_config/1","type":"function"},{"doc":"Sends an interaction event to an animation.","ref":"RGBMatrix.Animation.html#interact/2","title":"RGBMatrix.Animation.interact/2","type":"function"},{"doc":"","ref":"RGBMatrix.Animation.html#c:interact/3","title":"RGBMatrix.Animation.interact/3","type":"callback"},{"doc":"Returns an animation's initial state.","ref":"RGBMatrix.Animation.html#new/2","title":"RGBMatrix.Animation.new/2","type":"function"},{"doc":"","ref":"RGBMatrix.Animation.html#c:new/2","title":"RGBMatrix.Animation.new/2","type":"callback"},{"doc":"Returns the next state of an animation based on its current state.","ref":"RGBMatrix.Animation.html#render/1","title":"RGBMatrix.Animation.render/1","type":"function"},{"doc":"","ref":"RGBMatrix.Animation.html#c:render/2","title":"RGBMatrix.Animation.render/2","type":"callback"},{"doc":"Returns a human-readable name for an animation type.","ref":"RGBMatrix.Animation.html#type_name/1","title":"RGBMatrix.Animation.type_name/1","type":"function"},{"doc":"Returns a list of the available types of animations.","ref":"RGBMatrix.Animation.html#types/0","title":"RGBMatrix.Animation.types/0","type":"function"},{"doc":"Updates the configuration of an animation and returns the updated animation.","ref":"RGBMatrix.Animation.html#update_config/2","title":"RGBMatrix.Animation.update_config/2","type":"function"},{"doc":"","ref":"RGBMatrix.Animation.html#t:animation_state/0","title":"RGBMatrix.Animation.animation_state/0","type":"type"},{"doc":"","ref":"RGBMatrix.Animation.html#t:render_in/0","title":"RGBMatrix.Animation.render_in/0","type":"type"},{"doc":"","ref":"RGBMatrix.Animation.html#t:t/0","title":"RGBMatrix.Animation.t/0","type":"type"},{"doc":"","ref":"RGBMatrix.Animation.html#t:type/0","title":"RGBMatrix.Animation.type/0","type":"type"},{"doc":"Single hue brightness cycling.","ref":"RGBMatrix.Animation.Breathing.html","title":"RGBMatrix.Animation.Breathing","type":"module"},{"doc":"Provides a behaviour and macros for defining animation configurations.","ref":"RGBMatrix.Animation.Config.html","title":"RGBMatrix.Animation.Config","type":"behaviour"},{"doc":"Returns a map of field types provided by the Config module","ref":"RGBMatrix.Animation.Config.html#field_types/0","title":"RGBMatrix.Animation.Config.field_types/0","type":"function"},{"doc":"","ref":"RGBMatrix.Animation.Config.html#c:new/1","title":"RGBMatrix.Animation.Config.new/1","type":"callback"},{"doc":"Creates a new t/0 struct belonging to the provided Animation.&lt;type&gt;.Config module.The provided Config must be defined through the use Animation and field macros in an Animation.&lt;type&gt; module.The params provided are a map of creation_params/0.Returns a t/0 struct.Example:iex&gt; module = RGBMatrix.Animation.HueWave.Config iex&gt; schema = module.schema() iex&gt; params = %{direction: :up, width: 30} iex&gt; RGBMatrix.Animation.Config.new_config(module, schema, params) %RGBMatrix.Animation.HueWave.Config{direction: :up, speed: 4, width: 30}The above example shows setting the direction and width to non-default values.Any invalid keys in the creation_params/0 map will cause that param to be ignored. Invalid values for fields will be ignored. In both cases, the default provided to the type will be used as the initial value for that field.All errors will be logged.","ref":"RGBMatrix.Animation.Config.html#new_config/3","title":"RGBMatrix.Animation.Config.new_config/3","type":"function"},{"doc":"","ref":"RGBMatrix.Animation.Config.html#c:schema/0","title":"RGBMatrix.Animation.Config.schema/0","type":"callback"},{"doc":"","ref":"RGBMatrix.Animation.Config.html#c:update/2","title":"RGBMatrix.Animation.Config.update/2","type":"callback"},{"doc":"Updates the provided t/0 struct using the provided schema and params.The params are a map of update_params/0.Configs must be retrieved through the use of Xebow.get_animation_config/0, which will return both the config and the schema.Returns the updated t/0 struct.Example:iex&gt; {config, schema} = Xebow.get_animation_config() iex&gt; params = %{&quot;direction&quot; =&gt; &quot;left&quot;, speed: 8} iex&gt; RGBMatrix.Animation.Config.update_config(config, schema, params) %RGBMatrix.Animation.HueWave.Config{direction: :left, speed: 8, width: 20}The above example shows updating the direction and speed.Any errors encountered during update are logged, and the struct is returned unchanged.","ref":"RGBMatrix.Animation.Config.html#update_config/3","title":"RGBMatrix.Animation.Config.update_config/3","type":"function"},{"doc":"A map used during creation of an Animation.&lt;type&gt;.Config.The keys are defined by the first atom, the name, provided to an Animation's field definition(s) and must match the field being defined.The value should be appropriate for the specified field.","ref":"RGBMatrix.Animation.Config.html#t:creation_params/0","title":"RGBMatrix.Animation.Config.creation_params/0","type":"type"},{"doc":"A keyword list containing the configuration fields for an animation type.It provides the defaults for each field, the available parameters to configure (such as :default, :min, :options, and so on). It can provide :doc, a keyword list, for documentation such as a human-readable :name and :description.The keys are defined by the first atom, the name, provided to an Animation's field definition(s). The values are RGBMatrix.Animation.Config.FieldType.t/0 types.The documentation is optional and will be initialized to an empty list if omitted.","ref":"RGBMatrix.Animation.Config.html#t:schema/0","title":"RGBMatrix.Animation.Config.schema/0","type":"type"},{"doc":"A tuple of the form, {name, field}. name is one of the valid FieldType names and field is a RGBMatrix.Animation.Config.FieldType.t/0 struct.","ref":"RGBMatrix.Animation.Config.html#t:schema_field/0","title":"RGBMatrix.Animation.Config.schema_field/0","type":"type"},{"doc":"A struct containing runtime configuration for a specific animation.Example:RGBMatrix.Animation.HueWave.Config RGBMatrix.Animation.SolidReactive.ConfigConfigs should not be accessed or modified directly. Use the functions Xebow.get_animation_config/0 and Xebow.update_animation_config/1 for access and modification.","ref":"RGBMatrix.Animation.Config.html#t:t/0","title":"RGBMatrix.Animation.Config.t/0","type":"type"},{"doc":"A map used to update an Animation.&lt;type&gt;.Config.The keys are defined by the first atom, the name, provided to an Animation's field definition(s) and must match the field(s) being updated. The key may be a string or an atom.The value should be appropriate for the field.","ref":"RGBMatrix.Animation.Config.html#t:update_params/0","title":"RGBMatrix.Animation.Config.update_params/0","type":"type"},{"doc":"Provides a behaviour for defining animation configuration field types.","ref":"RGBMatrix.Animation.Config.FieldType.html","title":"RGBMatrix.Animation.Config.FieldType","type":"behaviour"},{"doc":"","ref":"RGBMatrix.Animation.Config.FieldType.html#c:cast/2","title":"RGBMatrix.Animation.Config.FieldType.cast/2","type":"callback"},{"doc":"","ref":"RGBMatrix.Animation.Config.FieldType.html#c:validate/2","title":"RGBMatrix.Animation.Config.FieldType.validate/2","type":"callback"},{"doc":"The possible error atoms during validation and update of configs","ref":"RGBMatrix.Animation.Config.FieldType.html#t:error/0","title":"RGBMatrix.Animation.Config.FieldType.error/0","type":"type"},{"doc":"Module names for defined field types","ref":"RGBMatrix.Animation.Config.FieldType.html#t:submodule/0","title":"RGBMatrix.Animation.Config.FieldType.submodule/0","type":"type"},{"doc":"A field struct, containing all defined config information for that specific field.","ref":"RGBMatrix.Animation.Config.FieldType.html#t:t/0","title":"RGBMatrix.Animation.Config.FieldType.t/0","type":"type"},{"doc":"A value which is appropriate for a defined field and does not require casting to be used for config creation or update.","ref":"RGBMatrix.Animation.Config.FieldType.html#t:value/0","title":"RGBMatrix.Animation.Config.FieldType.value/0","type":"type"},{"doc":"An integer field type for use in animation configuration.Supports defining a minimum and a maximum, as well as a step value.To define an integer field in an animation, specify :integer as the field type.Example:field :speed, :integer, default: 4, min: 0, max: 32, doc: [ name: &quot;Speed&quot;, description: &quot;&quot;&quot; Controls the speed at which the wave moves across the matrix. &quot;&quot;&quot; ]","ref":"RGBMatrix.Animation.Config.FieldType.Integer.html","title":"RGBMatrix.Animation.Config.FieldType.Integer","type":"module"},{"doc":"","ref":"RGBMatrix.Animation.Config.FieldType.Integer.html#t:t/0","title":"RGBMatrix.Animation.Config.FieldType.Integer.t/0","type":"type"},{"doc":"","ref":"RGBMatrix.Animation.Config.FieldType.Integer.html#t:value/0","title":"RGBMatrix.Animation.Config.FieldType.Integer.value/0","type":"type"},{"doc":"An option field type for use in animation configuration.Supports defining a list of pre-defined options as atoms.To define an option field in an animation, specify :option as the field type.Example:field :direction, :option, default: :right, options: ~w(right left up down)a, # This must be a list of atoms doc: [ name: &quot;Direction&quot;, description: &quot;&quot;&quot; Controls the direction of the wave &quot;&quot;&quot; ] # This options list produces the same result as above: options: [ :right, :left, :up, :down ]","ref":"RGBMatrix.Animation.Config.FieldType.Option.html","title":"RGBMatrix.Animation.Config.FieldType.Option","type":"module"},{"doc":"","ref":"RGBMatrix.Animation.Config.FieldType.Option.html#t:t/0","title":"RGBMatrix.Animation.Config.FieldType.Option.t/0","type":"type"},{"doc":"","ref":"RGBMatrix.Animation.Config.FieldType.Option.html#t:value/0","title":"RGBMatrix.Animation.Config.FieldType.Option.value/0","type":"type"},{"doc":"Cycles the hue of all LEDs at the same time.","ref":"RGBMatrix.Animation.CycleAll.html","title":"RGBMatrix.Animation.CycleAll","type":"module"},{"doc":"Creates a wave of shifting hue that moves across the matrix.","ref":"RGBMatrix.Animation.HueWave.html","title":"RGBMatrix.Animation.HueWave","type":"module"},{"doc":"Cycles hue in a pinwheel pattern.","ref":"RGBMatrix.Animation.Pinwheel.html","title":"RGBMatrix.Animation.Pinwheel","type":"module"},{"doc":"Changes every key pressed to a random color.","ref":"RGBMatrix.Animation.RandomKeypresses.html","title":"RGBMatrix.Animation.RandomKeypresses","type":"module"},{"doc":"A random solid color fills the entire matrix and changes every key-press.","ref":"RGBMatrix.Animation.RandomSolid.html","title":"RGBMatrix.Animation.RandomSolid","type":"module"},{"doc":"All LEDs are a solid color.","ref":"RGBMatrix.Animation.SolidColor.html","title":"RGBMatrix.Animation.SolidColor","type":"module"},{"doc":"Static single hue, pulses keys hit to shifted hue then fades to current hue.","ref":"RGBMatrix.Animation.SolidReactive.html","title":"RGBMatrix.Animation.SolidReactive","type":"module"},{"doc":"Renders Animations and outputs colors to be displayed by anything that registers itself with register_paintable/2.","ref":"RGBMatrix.Engine.html","title":"RGBMatrix.Engine","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"RGBMatrix.Engine.html#child_spec/1","title":"RGBMatrix.Engine.child_spec/1","type":"function"},{"doc":"Sends interaction events to the engine. Animations may or may not respond to these interaction events.","ref":"RGBMatrix.Engine.html#interact/1","title":"RGBMatrix.Engine.interact/1","type":"function"},{"doc":"Register a paint function for the engine to send frames to.This function is idempotent.","ref":"RGBMatrix.Engine.html#register_paintable/1","title":"RGBMatrix.Engine.register_paintable/1","type":"function"},{"doc":"Sets the given animation as the currently active animation.","ref":"RGBMatrix.Engine.html#set_animation/1","title":"RGBMatrix.Engine.set_animation/1","type":"function"},{"doc":"Start the engine.This module registers its process globally and is expected to be started by a supervisor.","ref":"RGBMatrix.Engine.html#start_link/1","title":"RGBMatrix.Engine.start_link/1","type":"function"},{"doc":"Unregister a paint function so the engine no longer sends frames to it.This function is idempotent.","ref":"RGBMatrix.Engine.html#unregister_paintable/1","title":"RGBMatrix.Engine.unregister_paintable/1","type":"function"},{"doc":"","ref":"RGBMatrix.Engine.html#t:frame/0","title":"RGBMatrix.Engine.frame/0","type":"type"},{"doc":"Shared utility functions that are generally useful.","ref":"RGBMatrix.Utils.html","title":"RGBMatrix.Utils","type":"module"},{"doc":"Modulo operation that supports negative numbers.This is effectively mod as it exists in most other languages. Elixir's rem doesn't act the same as other languages for negative numbers.","ref":"RGBMatrix.Utils.html#mod/2","title":"RGBMatrix.Utils.mod/2","type":"function"},{"doc":"RGBMatrix RGBMatrix is a rendering engine for the Nerves Keyboard project. It schedules and renders frames. There is a small selection of animations built in.A layout of LEDs must be defined to use animations. The layout is handled by KeyboardLayout, which is included as a dependency. See the documentation for that library for how to define layouts.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding rgb_matrix to your list of dependencies in mix.exs:def deps do [ {:rgb_matrix, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"This library is licensed under the MIT license","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"MIT LicenseCopyright &amp;copy; 2020 Nerves Keyboard groupPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]